<template>
    <div id="dropzone" ref="dzone" tabindex="0" class="v-slide-item--active">
        <v-row>
            <v-col cols="3">
                <v-card class="uploader" height="165" width="100" :style="style" :img="URI_FLAG" v-cloak>Actual</v-card>
            </v-col>
            <v-col>
                <v-card
                    class="mx-auto sheet"
                    max-width="800"
                    color="#FFF9C4"
                    @drop.prevent="fileDropped"
                    @dragenter.prevent="dragover = true"
                    @dragleave.prevent="dragover = false"
                    @dragover.prevent="dragover = true"
                    flat
                >
                    <v-icon
                        class="drop-icon"
                        v-if="dragover"
                        color="yellow darken-2"
                        size="50"
                        style="pointer-events: none;"
                        >mdi-book-plus</v-icon
                    >
                    <v-file-input
                        :key="uploaderKey"
                        ref="uploader"
                        class="d-none"
                        accept="image/*"
                        @change="fileUpload"
                        multiple
                    ></v-file-input>
                    <div class="drop-zone">
                        <v-slide-group ref="slider" show-arrows center-active width="100">
                            <v-slide-item v-for="(file, key) in filesDish" :key="key" v-slot:default="{ active }">
                                <v-card
                                    :ref="'preview' + key"
                                    :color="active ? undefined : 'grey lighten-1'"
                                    class="ma-3 preview"
                                    height="80%"
                                    style="height: 13vh;"
                                    width="70"
                                    :img="previewImg(file, key)"
                                    @click="$refs['uploader' + key][0].$refs.input.click()"
                                    @mouseover.native="toggle = key"
                                    @mouseleave.native="toggle = null"
                                >
                                    <v-btn class="close" @click="fileRemove(file, key)" height="20" width="20" fab
                                        ><span>&times;</span></v-btn
                                    >
                                    <v-file-input
                                        :ref="'uploader' + key"
                                        class="d-none"
                                        accept="image/*"
                                        :value="file"
                                        @change="fileChange($event, key)"
                                    ></v-file-input>
                                </v-card>
                            </v-slide-item>
                        </v-slide-group>
                    </div>
                </v-card>
                <v-btn
                    class="add"
                    width="40%"
                    style="float: left; margin:10%; margin-top: 2px!important"
                    @click="$refs.uploader.$refs.input.click()"
                    depressed
                    >+ Agregar icono</v-btn
                >
            </v-col>
        </v-row>
    </div>
</template>
<script lang="ts">
import Vue from 'vue';
import { Component, Emit, Prop, Watch } from 'vue-property-decorator';
import { getFile } from '@/services/StorageService';

interface SlideGroup {
    scrollOffset: number;
    items: Card[];
}

interface Card {
    style: {
        backgroundImage: string;
    };
}
@Component
export default class DragAndDrop extends Vue {
    @Prop({ default: '' })
    uri!: string;
    URI_FLAG = '';

    @Prop({ default: () => [] })
    files!: string[];
    @Prop({ default: () => 1 })
    max!: number;
    @Prop({ default: () => 1 })
    resetOffset!: number;
    originalFilesPreview: string[] = [];
    originalFiles: File[] = [];
    newFiles: File[] = [];
    uploaderKey = 0;
    size = '50px';
    dragover = false;
    toggle = null;

    @Watch('uri')
    async onChangeData(newData: string) {
        this.URI_FLAG = await getFile(newData);
    }
    get style() {
        let rules = `border-radio:50%;`;
        rules += `background-image: url('${this.URI_FLAG}');`;
        rules += `background-size: contain;`;
        rules += `background-repeat: no-repeat;`;
        rules += `line-height: ${this.size}`;
        rules += `background-color: #dae0e2;`;
        rules += `background-position: center`;
        return rules;
    }
    async mounted() {
        this.URI_FLAG = await getFile(this.uri);
        await this.onOriginalFilesChanged();

        // to register listeners, we have to know the
        // html elements
        const dropzone = this.$el;
        // register listeners on your dropzone / v-sheet

        if (dropzone) {
            // register all drag & drop event listeners
            dropzone.addEventListener('dragenter', e => {
                e.preventDefault();
                this.dragover = true;
            });
            dropzone.addEventListener('dragleave', e => {
                e.preventDefault();
                this.dragover = false;
            });
            dropzone.addEventListener('dragover', e => {
                e.preventDefault();
                this.dragover = true;
            });
            dropzone.addEventListener('drop', e => {
                e.preventDefault();
                const dragevent = e as DragEvent;
                if (dragevent.dataTransfer) {
                    this.filesSelected(dragevent.dataTransfer.files);
                }
            });
        }
    }
    /**
     * upload event...
     */
    @Emit()
    filesSelected(fileList: FileList) {
        this.dragover = false;
    }

    fileDropped(dragevent: DragEvent) {
        if (dragevent.dataTransfer) {
            this.newFiles.push(...dragevent.dataTransfer.files);
            this.$emit('filesChanged', this.newFiles);
            this.dragover = false;
        }
    }

    fileUpload(files: File[]) {
        this.newFiles.push(...files);
        this.$emit('filesChanged', this.newFiles);
        this.uploaderKey++;
    }

    fileChange(file: File, key: number) {
        this.newFiles.splice(key, 1, file);
        this.$emit('filesChanged', this.newFiles);
    }

    fileRemove(file: File, index: number) {
        try {
            this.newFiles.splice(this.newFiles.indexOf(file), 1);
            this.originalFilesPreview.splice(index, 1);
            this.$emit('filesChanged', this.newFiles);
            if (this.newFiles.length < this.resetOffset) {
                this.resetSlider();
            }
        } catch (e) {
            console.log('');
        }
    }

    resetSlider() {
        ((this.$refs.slider as unknown) as SlideGroup).scrollOffset = 0;
    }

    previewImg(file: File, key: number) {
        if (file.size !== 0) {
            return URL.createObjectURL(file);
        } else {
            return this.originalFilesPreview[key];
        }
    }

    async getFilesPreview() {
        return Promise.all(this.files.map(async file => (await getFile(file)) || ''));
    }

    @Watch('files')
    async onOriginalFilesChanged() {
        this.newFiles = [];
        if (this.files) {
            try {
                this.originalFiles = this.files.map(file => new File([], file, { type: 'image/png' }));
                this.originalFilesPreview = await this.getFilesPreview();
                this.newFiles = this.originalFiles;
            } catch (e) {
                console.log('');
            }
        }
    }

    get filesDish() {
        return this.newFiles;
    }
}
</script>

<style>
.upload-control {
    align-content: center;
}
.uploadLabel {
    padding: 0 15px 0 15px;
    text-align: center;
    font-size: 15px;
}
.uploader {
    border: 7px;
    border-style: dashed;
    border-color: #dde3f3 !important;
}
.sheet {
    border: 2px dashed;
    border-color: #f0c74b !important;
    height: 17vh;
    width: 40vh;
}
.drop-zone {
    display: flex;
    align-items: center;
    position: relative;
}
.drop-icon {
    width: 100%;
    height: 100%;
    background: rgba(253, 185, 71, 0.6);
    position: absolute !important;
    z-index: 1;
    transition: all 0.5s;
    -webkit-transition: all 0.5s;
}
.edit-icon {
    position: relative;
    top: calc(50% - 10px);
}
.close {
    position: absolute;
    background: #fff;
    right: -10px;
}
.close span {
    color: #000;
    font-weight: 700;
    font-size: 20px;
}
.preview {
    background-position: center;
    background-size: contain;
}
</style>
